/*
Copyright 2021 The Volcano Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
	v1alpha1 "volcano.sh/apis/pkg/apis/nodeinfo/v1alpha1"
)

// FakeNumatopos implements NumatopoInterface
type FakeNumatopos struct {
	Fake *FakeNodeinfoV1alpha1
	ns   string
}

var numatoposResource = schema.GroupVersionResource{Group: "nodeinfo.volcano.sh", Version: "v1alpha1", Resource: "numatopos"}

var numatoposKind = schema.GroupVersionKind{Group: "nodeinfo.volcano.sh", Version: "v1alpha1", Kind: "Numatopo"}

// Get takes name of the numatopo, and returns the corresponding numatopo object, and an error if there is any.
func (c *FakeNumatopos) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.Numatopo, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(numatoposResource, c.ns, name), &v1alpha1.Numatopo{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.Numatopo), err
}

// List takes label and field selectors, and returns the list of Numatopos that match those selectors.
func (c *FakeNumatopos) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.NumatopoList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(numatoposResource, numatoposKind, c.ns, opts), &v1alpha1.NumatopoList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1alpha1.NumatopoList{ListMeta: obj.(*v1alpha1.NumatopoList).ListMeta}
	for _, item := range obj.(*v1alpha1.NumatopoList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested numatopos.
func (c *FakeNumatopos) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(numatoposResource, c.ns, opts))

}

// Create takes the representation of a numatopo and creates it.  Returns the server's representation of the numatopo, and an error, if there is any.
func (c *FakeNumatopos) Create(ctx context.Context, numatopo *v1alpha1.Numatopo, opts v1.CreateOptions) (result *v1alpha1.Numatopo, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(numatoposResource, c.ns, numatopo), &v1alpha1.Numatopo{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.Numatopo), err
}

// Update takes the representation of a numatopo and updates it. Returns the server's representation of the numatopo, and an error, if there is any.
func (c *FakeNumatopos) Update(ctx context.Context, numatopo *v1alpha1.Numatopo, opts v1.UpdateOptions) (result *v1alpha1.Numatopo, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(numatoposResource, c.ns, numatopo), &v1alpha1.Numatopo{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.Numatopo), err
}

// Delete takes name of the numatopo and deletes it. Returns an error if one occurs.
func (c *FakeNumatopos) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(numatoposResource, c.ns, name), &v1alpha1.Numatopo{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeNumatopos) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(numatoposResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &v1alpha1.NumatopoList{})
	return err
}

// Patch applies the patch and returns the patched numatopo.
func (c *FakeNumatopos) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.Numatopo, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(numatoposResource, c.ns, name, pt, data, subresources...), &v1alpha1.Numatopo{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.Numatopo), err
}
