/*
Copyright 2021 The Volcano Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
// Code generated by client-gen. DO NOT EDIT.

package v1alpha1

import (
	"context"
	"time"

	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
	v1alpha1 "volcano.sh/apis/pkg/apis/nodeinfo/v1alpha1"
	scheme "volcano.sh/apis/pkg/client/clientset/versioned/scheme"
)

// NumatoposGetter has a method to return a NumatopoInterface.
// A group's client should implement this interface.
type NumatoposGetter interface {
	Numatopos(namespace string) NumatopoInterface
}

// NumatopoInterface has methods to work with Numatopo resources.
type NumatopoInterface interface {
	Create(ctx context.Context, numatopo *v1alpha1.Numatopo, opts v1.CreateOptions) (*v1alpha1.Numatopo, error)
	Update(ctx context.Context, numatopo *v1alpha1.Numatopo, opts v1.UpdateOptions) (*v1alpha1.Numatopo, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*v1alpha1.Numatopo, error)
	List(ctx context.Context, opts v1.ListOptions) (*v1alpha1.NumatopoList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.Numatopo, err error)
	NumatopoExpansion
}

// numatopos implements NumatopoInterface
type numatopos struct {
	client rest.Interface
	ns     string
}

// newNumatopos returns a Numatopos
func newNumatopos(c *NodeinfoV1alpha1Client, namespace string) *numatopos {
	return &numatopos{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the numatopo, and returns the corresponding numatopo object, and an error if there is any.
func (c *numatopos) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.Numatopo, err error) {
	result = &v1alpha1.Numatopo{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("numatopos").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do(ctx).
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of Numatopos that match those selectors.
func (c *numatopos) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.NumatopoList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1alpha1.NumatopoList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("numatopos").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do(ctx).
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested numatopos.
func (c *numatopos) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("numatopos").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch(ctx)
}

// Create takes the representation of a numatopo and creates it.  Returns the server's representation of the numatopo, and an error, if there is any.
func (c *numatopos) Create(ctx context.Context, numatopo *v1alpha1.Numatopo, opts v1.CreateOptions) (result *v1alpha1.Numatopo, err error) {
	result = &v1alpha1.Numatopo{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("numatopos").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(numatopo).
		Do(ctx).
		Into(result)
	return
}

// Update takes the representation of a numatopo and updates it. Returns the server's representation of the numatopo, and an error, if there is any.
func (c *numatopos) Update(ctx context.Context, numatopo *v1alpha1.Numatopo, opts v1.UpdateOptions) (result *v1alpha1.Numatopo, err error) {
	result = &v1alpha1.Numatopo{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("numatopos").
		Name(numatopo.Name).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(numatopo).
		Do(ctx).
		Into(result)
	return
}

// Delete takes name of the numatopo and deletes it. Returns an error if one occurs.
func (c *numatopos) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("numatopos").
		Name(name).
		Body(&opts).
		Do(ctx).
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *numatopos) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	var timeout time.Duration
	if listOpts.TimeoutSeconds != nil {
		timeout = time.Duration(*listOpts.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Namespace(c.ns).
		Resource("numatopos").
		VersionedParams(&listOpts, scheme.ParameterCodec).
		Timeout(timeout).
		Body(&opts).
		Do(ctx).
		Error()
}

// Patch applies the patch and returns the patched numatopo.
func (c *numatopos) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.Numatopo, err error) {
	result = &v1alpha1.Numatopo{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("numatopos").
		Name(name).
		SubResource(subresources...).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(data).
		Do(ctx).
		Into(result)
	return
}
